//modified: 2003.02.03@21:20 by Alex

//2001.11.19
//* first version
//2001.11.21
//* all available ports are listed in ComboPort
//* if ports already opened by another app CmdOpen isn't disabled
//* in EditSend: '##' now means '#', '<<' = '<'
//* introduced more options for Com (DTRControl, RTSControl, FlowControl, Xon, Break, RTS, invert TXEN, Parity, TXempty anzeigen)
//2001.11.23
//* fixed bug in  FlowControl.Items (mixed order)
//* introduced reopening of port each time when an option is changed
//* EditSend now accepts "#2j"-like stuff instead of having to write "#002" (formerly three digits required)
//  * now the number is max 5 non-characters (=digits) long
//* option for databits and stopbits
//2001.11.25
//* changed ComboParityChange
//* introduced chr<->ord translator
//2001.12.02
//* CheckBreakClick calls ReOpenCom
//* asc>127 are encoded, MemoOut now gets encoded, too
//2001.12.03
//* Sending resets Break
//* Received bytes are written to MemoIn by a timer
//* app listens on port 666 for incoming connections which send data to be sent to com ('SEND blabla' -> sends 'blabla')
//* added event handler for CheckInvTXENClick
//2001.12.06
//* adjusted TForm1.SendText
//* changed way of handling ReadBuffer (Timer's no longer called regularly but actually a kind of timeout for receiving)
//*2001.12.11
//* fixed input '<b>' -> output '<b>'
//* fixed bug that regular receiving prohibits update of memoin
//2001.12.19
//* auto connect + multiserver support
//2001.12.21
//* changed interlink commands to 'SEND', 'SENT' and 'RCVD'
//* interlink server v1.1 (with ilbuffer)
//2002.01.02
//* time's added to 'SENT' and 'RCVD'
//2002.02.24
//* toggle TXEN by STRG+T
//2002.03.10
//* option for switching TXEN on TXempty
//* extended memos' pop-up menus
//2002.03.18
//* bug-fix: changing com-port while port opened did not work
//2003.02.03
//* updated port read out from registry

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, VaClasses, VaComm, Menus, Registry, ComCtrls, VaConst,
  Math, WSocket, WSocketS, ActnList, Clipbrd;

type
  {TMyMemo = class(TMemo)
    procedure FTextWrite(text:string);
    protected
      Ftext:string;
    public
      ShowASC:boolean;
      property text:string read Ftext write FTextWrite;
  end;}
  TForm1 = class(TForm)
    CmdOpen: TButton;
    CmdClose: TButton;
    MemoIn: TMemo;
    MemoOut: TMemo;
    ComboBaud: TComboBox;
    ComboPort: TComboBox;
    CheckTXEN: TCheckBox;
    EditSend: TEdit;
    CmdSend: TButton;
    PopupMenu1: TPopupMenu;
    PopClearMemo: TMenuItem;
    CheckCRNL: TCheckBox;
    CheckSaveMemo: TCheckBox;
    ComboFC: TComboBox;
    CheckDecode: TCheckBox;
    PageOptions: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    CheckInvTXEN: TCheckBox;
    ComboDTRControl: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    CheckRTS: TCheckBox;
    CheckBreak: TCheckBox;
    CheckXon: TCheckBox;
    CheckTXEmpty: TCheckBox;
    Label3: TLabel;
    ComboRTSControl: TComboBox;
    PopClearMemos: TMenuItem;
    ComboParity: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Com: TVaComm;
    Label7: TLabel;
    ComboStopbits: TComboBox;
    Label8: TLabel;
    ComboDatabits: TComboBox;
    EditChr: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    EditOrd: TEdit;
    TimerUpdateMemoIn: TTimer;
    ImageConnect: TImage;
    Server: TWSocketServer;
    TimerUpdateFinally: TTimer;
    Client: TWSocket;
    ActionList1: TActionList;
    SwitchTXEN: TAction;
    Label11: TLabel;
    CheckSwitchTXENOnTXEmpty: TCheckBox;
    N1: TMenuItem;
    PopCut: TMenuItem;
    PopCopy: TMenuItem;
    PopMarkAll: TMenuItem;
    procedure ComboBaudChange(Sender: TObject);
    procedure CmdOpenClick(Sender: TObject);
    procedure CmdCloseClick(Sender: TObject);
    procedure ComboPortChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckTXENClick(Sender: TObject);
    procedure ComRxChar(Sender: TObject; Count: Integer);
    procedure CmdSendClick(Sender: TObject);
    procedure PopClearMemoClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function  DecodeText(text:string):string;
    procedure ComboFCChange(Sender: TObject);
    procedure ComError(Sender: TObject; Errors: Integer);
    procedure ComboDTRControlChange(Sender: TObject);
    procedure CheckRTSClick(Sender: TObject);
    procedure CheckBreakClick(Sender: TObject);
    procedure CheckXonClick(Sender: TObject);
    procedure ComTxEmpty(Sender: TObject);
    procedure ComboRTSControlChange(Sender: TObject);
    procedure PopClearMemosClick(Sender: TObject);
    procedure ComboParityChange(Sender: TObject);
    procedure ComOpen(Sender: TObject);
    procedure ComClose(Sender: TObject);
    procedure ComboStopbitsChange(Sender: TObject);
    procedure ReOpenCom;
    procedure ComboDatabitsChange(Sender: TObject);
    procedure EditSendKeyPress(Sender: TObject; var Key: Char);
    procedure AppException(Sender: TObject; E: Exception);
    procedure EditOrdKeyPress(Sender: TObject; var Key: Char);
    procedure EditOrdChange(Sender: TObject);
    procedure EditChrKeyPress(Sender: TObject; var Key: Char);
    procedure LogOut(text:string);
    procedure TimerUpdateMemoInTimer(Sender: TObject);
    procedure ComBreak(Sender: TObject);
    procedure SendText(text:string);
    procedure ServerClientConnect(Sender: TObject;  Client: TWSocketClient; Error: Word);
    procedure ServerClientDisconnect(Sender: TObject; Client: TWSocketClient; Error: Word);
    procedure ServerDataAvailable(Sender: TObject; Error: Word);
    procedure CheckInvTXENClick(Sender: TObject);
    procedure TimerUpdateFinallyTimer(Sender: TObject);
    procedure ILSend(data:string);
    procedure ILGet (text:string);
    procedure ClientDataAvailable(Sender: TObject; Error: Word);
    procedure ClientSessionConnected(Sender: TObject; Error: Word);
    procedure FormShow(Sender: TObject);
    procedure ServerSessionConnected(Sender: TObject; Error: Word);
    function  MyStr(x,w:integer):string;
    procedure ClientSessionClosed(Sender: TObject; Error: Word);
    procedure SwitchTXENExecute(Sender: TObject);
    procedure PopCutClick(Sender: TObject);
    procedure PopCopyClick(Sender: TObject);
    procedure PopMarkAllClick(Sender: TObject);
    procedure EditChrChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

  TMyRegistry = class(TRegistry)
    function ReadStringD(key:string;default:string):string;
    function ReadIntegerD(key:string;default:integer):integer;
  end;

var
  Form1     : TForm1;
  use       : array of TWSocket;
  started   : boolean;
  ReadBuffer: String; //temp storage for data received from Com
  ilbuffer  : string;

const
  BaseRegKey='Software\85\Seriell Port Debug\';

implementation

{$R *.DFM}

{procedure TMyMemo.FTextWrite(text:string);
//sets new text of memo
var
  b:string;
  i:integer;
begin
  for i:=1 to length(text) do
    if ord(text[i])<32 then
      b:=b+'<'+inttostr(ord(text[i]))+'>'
    else
      b:=b+text[i];
  FText:=b;
end;}

procedure TForm1.ComboBaudChange(Sender: TObject);
begin
  Com.BaudRate := TVaBaudrate(ComboBaud.ItemIndex);
  ReOpenCom;
end;

procedure TForm1.CmdOpenClick(Sender: TObject);
begin
  CmdOpen.Enabled:=false;
  try
    Com.Open;
  except
    CmdOpen.Enabled:=true;
    raise;//->exit
  end;
  CmdClose.Enabled:=true;
end;

procedure TForm1.CmdCloseClick(Sender: TObject);
begin
  CmdOpen.Enabled:=true;
  Com.Close;
  CmdClose.Enabled:=false;
end;

procedure TForm1.ComboPortChange(Sender: TObject);
begin
  if Com.Active then begin
    CmdClose.Enabled:=false;
    Com.Close;
    Com.PortNum:=strtoint(copy(ComboPort.Text,4,1));
    Com.Open;
    CmdClose.Enabled:=true;
  end else
    Com.PortNum:=strtoint(copy(ComboPort.Text,4,1));
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Registry : TMyRegistry;
  a        : string;
  i        : integer;
begin
  Application.OnException:=AppException;
  Registry:=TMyRegistry.Create;
  //read available com ports
  Registry.RootKey := HKEY_LOCAL_MACHINE;
  Registry.OpenKey('hardware\devicemap\serialcomm',false);
  Registry.GetValueNames(ComboPort.Items);
  for i := 0 to ComboPort.Items.Count-1 do begin
    ComboPort.Items.Strings[i] :=
    Registry.ReadString(ComboPort.Items.Strings[i]);
  end;
  Registry.CloseKey; // ab hier: alt
  //read (and set) preferences
  Registry.RootKey:=HKEY_CURRENT_USER;
  Registry.OpenKey(BaseRegKey,true);
  ComboPort.ItemIndex:=Registry.ReadIntegerD('PortNumIndex',0);
  ComboBaud.ItemIndex:=Registry.ReadIntegerD('BaudRateIndex',1);
   ComboBaudChange(self);
  ComboFC.ItemIndex:=Registry.ReadIntegerD('FlowControlIndex',2);
   ComboFCChange(self);
  ComboDTRControl.ItemIndex:=Registry.ReadIntegerD('DTRControlIndex',0);
   ComboDTRControlChange(self);
  ComboRTSControl.ItemIndex:=Registry.ReadIntegerD('RTSControlIndex',1);
   ComboRTSControlChange(self);
  ComboParity.ItemIndex:=Registry.ReadIntegerD('ParityIndex',2);
   ComboParityChange(self);
  ComboStopbits.ItemIndex:=Registry.ReadIntegerD('StopbitsIndex',0);
   ComboStopbitsChange(self);
  ComboDatabits.ItemIndex:=Registry.ReadIntegerD('DatabitsIndex',4);
   ComboDatabitsChange(self);
  a:=Registry.ReadStringD('TXEN','true');
  CheckTXEN.Checked:=(a='true');
  a:=Registry.ReadStringD('send #13#10','true');
  CheckCRNL.Checked:=(a='true');
  a:=Registry.ReadStringD('save memos','true');
  CheckSaveMemo.Checked:=(a='true');
  a:=Registry.ReadStringD('decode asc<32','true');
  CheckDecode.Checked:=(a='true');
  a:=Registry.ReadStringD('Invert TXEN','true');
  CheckInvTXEN.Checked:=(a='true');
  a:=Registry.ReadStringD('RTS','false');
  CheckRTS.Checked:=(a='true');
  a:=Registry.ReadStringD('Xon','false');
  CheckXon.Checked:=(a='true');
  a:=Registry.ReadStringD('Break','false');
  CheckBreak.Checked:=(a='true');
  a:=Registry.ReadStringD('TXempty','true');
  CheckTXEmpty.Checked:=(a='true');
  a:=Registry.ReadStringD('AutoSwitch TXEN','true');
  CheckSwitchTXENOnTXEmpty.Checked:=(a='true');
  MemoIn.Text:=Registry.ReadStringD('MemoIn','');
  MemoOut.Text:=Registry.ReadStringD('MemoOut','');
  EditSend.Text:=Registry.ReadStringD('EditSend','');
  Registry.CloseKey;
  Registry.Free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Registry : TMyRegistry;
  a        : string;
begin
  if Com.Active then Com.Close;
  Registry:=TMyRegistry.Create;
  Registry.RootKey:=HKEY_CURRENT_USER;
  Registry.OpenKey(BaseRegKey,true);
  //write preferences
  Registry.WriteInteger('PortNumIndex',ComboPort.ItemIndex);
  Registry.WriteInteger('BaudRateIndex',ComboBaud.ItemIndex);
  Registry.WriteInteger('FlowControlIndex',ComboFC.ItemIndex);
  Registry.WriteInteger('DTRControlIndex',ComboDTRControl.ItemIndex);
  Registry.WriteInteger('RTSControlIndex',ComboRTSControl.ItemIndex);
  Registry.WriteInteger('ParityIndex',ComboParity.ItemIndex);
  Registry.WriteInteger('StopbitsIndex',ComboStopbits.ItemIndex);
  Registry.WriteInteger('DatabitsIndex',ComboDatabits.ItemIndex);
  if CheckTXEN.Checked then a:='true' else a:='false';
  Registry.WriteString('TXEN',a);
  if CheckCRNL.Checked then a:='true' else a:='false';
  Registry.WriteString('send #13#10',a);
  if CheckSaveMemo.Checked then a:='true' else a:='false';
  Registry.WriteString('save memos',a);
  if CheckDecode.Checked then a:='true' else a:='false';
  Registry.WriteString('decode asc<32',a);
  if CheckInvTXEN.Checked then a:='true' else a:='false';
  Registry.WriteString('Invert TXEN',a);
  if CheckRTS.Checked then a:='true' else a:='false';
  Registry.WriteString('RTS',a);
  if CheckXon.Checked then a:='true' else a:='false';
  Registry.WriteString('Xon',a);
  if CheckBreak.Checked then a:='true' else a:='false';
  Registry.WriteString('Break',a);
  if CheckTXEmpty.Checked then a:='true' else a:='false';
  Registry.WriteString('TXempty',a);
  if CheckSwitchTXENOnTXEmpty.Checked then a:='true' else a:='false';
  Registry.WriteString('AutoSwitch TXEN',a);
  if CheckSaveMemo.Checked then
    a:=MemoIn.Text else a:='';
  Registry.WriteString('MemoIn',a);
  if CheckSaveMemo.Checked then
    a:=MemoOut.Text else a:='';
  Registry.WriteString('MemoOut',a);
  if CheckSaveMemo.Checked then
    a:=EditSend.Text else a:='';
  Registry.WriteString('EditSend',a);
  Registry.Free;
end;

procedure TForm1.CheckTXENClick(Sender: TObject);
begin
  Com.SetDTRState(CheckTXEN.Checked xor CheckInvTXEN.Checked);
  if CheckTXEN.Checked then
    CheckTXEN.Caption:='&TXEN (Senden)'
  else
    CheckTXEN.Caption:='&TXEN (Empfangen)'
end;

procedure TForm1.ComRxChar(Sender: TObject; Count: Integer);
begin
  TimerUpdateMemoIn.Enabled:=false;
  ReadBuffer:=ReadBuffer+Com.ReadText;
  TimerUpdateMemoIn.Enabled:=true;
  TimerUpdateFinally.Enabled:=true;//if every 10 ms sth is received, memoin would never be updated 
end;

procedure TForm1.CmdSendClick(Sender: TObject);
//send text of EditSend.Text
var
  a : string;
begin
  a:=EditSend.Text;
  if CheckCRNL.Checked then a:=a+#13#10;
  if CheckSwitchTXENOnTXEmpty.Checked then
    CheckTXEN.Checked:=true;
  SendText(a);
end;

procedure TForm1.SendText(text:string);
//parse and send text
var
  a  :string;
  i,j:integer;
begin
  CheckBreak.Checked:=false;
  if not Com.Active then CmdOpenClick(self);
  i:=1;
  while i<=length(text) do begin
    case text[i] of
      '#':if text[i+1]='#' then begin
            a:=a+'#';
            inc(i);
          end else begin
            j:=i+1;
            while (j<=length(text)) and (text[j]<>'>') and
                  ((text[j]>='0') and (text[j]<='9')) do inc(j);
            if j>i+1 then
              a:=a+chr(strtoint(copy(text,i+1,min(3,j-i-1))))
            else
              a:=a+'#';
            inc(i,min(3,j-i-1));
          end;
      '<':begin
          inc(i);
          if text[i]='<' then begin
            a:=a+'<';
          end else begin
            j:=i;
            while (j<=length(text)) and (text[j]<>'>') and
                  ((text[j]>='0') and (text[j]<='9')) do inc(j);
            if j>i then begin
              a:=a+chr(strtoint(copy(text,i,min(3,j-i))));
              inc(i,min(3,j-i));
              if text[i]<>'>' then dec(i);
            end else begin
              a:=a+'<';
              dec(i);
            end;
          end;
        end;
      else
        a:=a+text[i];
    end;
    inc(i);
  end;
  if not Com.WriteText(a) then
    LogOut('Fehler beim Senden')
  else begin
    ILSend('SENT'+mystr(GetTickCount,10)+a);
    LogOut(a);
  end;
end;

function TForm1.DecodeText(text:string):string;
//replaces chars<#32 and >#126 by their asc values
var
  i : integer;
  b : string;
begin
  for i:=1 to length(text) do
    if (text[i]<#32) or (text[i]>#126) then
      b:=b+'<'+inttostr(ord(text[i]))+'>'
    else
      b:=b+text[i];
  result:=b;
end;


//////////////////////////// MY REGISTRY ///////////////////////////////////////
function TMyRegistry.ReadStringD(key:string;default:string):string;
begin
  if ReadString(key)='' then
    result:=default
  else
    result:=ReadString(key);
end;

function TMyRegistry.ReadIntegerD(key:string;default:integer):integer;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=ReadInteger(key);
    except
      result:=default;
    end;
end;
procedure TForm1.ComboFCChange(Sender: TObject);
begin
  case ComboFC.ItemIndex of
    0:Com.FlowControl:=fcDtrDsr;
    1:Com.FlowControl:=fcNone;
    2:Com.FlowControl:=fcRtsCts;
    3:Com.FlowControl:=fcXonXoff;
  end;
  ReOpenCom;
end;

procedure TForm1.ComError(Sender: TObject; Errors: Integer);
var
  e:string;
begin
  if (Errors and CE_BREAK > 0)    then e:=sCE_BREAK;
  if (Errors and CE_DNS > 0)      then e:=sCE_DNS;
  if (Errors and CE_FRAME > 0)    then e:=sCE_FRAME;
  if (Errors and CE_IOE > 0)      then e:=sCE_IOE;
  if (Errors and CE_MODE > 0)     then e:=sCE_MODE;
  if (Errors and CE_OOP > 0)      then e:=sCE_OOP;
  if (Errors and CE_OVERRUN > 0)  then e:=sCE_OVERRUN;
  if (Errors and CE_PTO > 0)      then e:=sCE_PTO;
  if (Errors and CE_RXOVER > 0)   then e:=sCE_RXOVER;
  if (Errors and CE_RXPARITY > 0) then e:=sCE_RXPARITY;
  if (Errors and CE_TXFULL > 0)   then e:=sCE_TXFULL;
  LogOut('Die Com-Komponente hat einen Fehler ausgelst: '+e+' ('+inttostr(Errors)+')');
end;

procedure TForm1.ComboDTRControlChange(Sender: TObject);
begin
  case ComboDTRControl.ItemIndex of
    0:Com.DTRControl:=dtrDisable;
    1:Com.DTRControl:=dtrEnable;
    2:Com.DTRControl:=dtrHandshake;
  end;
  ReOpenCom;
end;

procedure TForm1.CheckRTSClick(Sender: TObject);
begin
  Com.SetRTSState(CheckRTS.Checked);
end;

procedure TForm1.CheckBreakClick(Sender: TObject);
begin
  Com.SetBreakState(CheckBreak.Checked);
  ReOpenCom;
end;

procedure TForm1.CheckXonClick(Sender: TObject);
begin
  Com.SetXonState(CheckXon.Checked);
end;

procedure TForm1.ComTxEmpty(Sender: TObject);
begin
  If CheckTXEmpty.Checked then LogOut('TXempty / Sendebuffer leer');
  if CheckSwitchTXENOnTXEmpty.Checked then
    CheckTXEN.Checked:=false;
end;

procedure TForm1.ComboRTSControlChange(Sender: TObject);
begin
  Com.RTSControl:=TVaRTSControl(ComboRTSControl.ItemIndex);
  if ComboRTSControl.ItemIndex=2 then
    CheckRTS.Enabled:=false //otherwise error: Manual rts line setting not allowed
  else
    CheckRTS.Enabled:=true;
  ReOpenCom;    
end;

procedure TForm1.ComboParityChange(Sender: TObject);
begin
  case ComboParity.ItemIndex of
    0:Com.Parity:=paEven;
    1:Com.Parity:=paMark;
    2:Com.Parity:=paNone;
    3:Com.Parity:=paOdd;
    4:Com.Parity:=paSpace;
  end;
  ReOpenCom;
end;

procedure TForm1.ComOpen(Sender: TObject);
begin
  LogOut('Port '+inttostr(Com.PortNum)+' offen.');
end;

procedure TForm1.ComClose(Sender: TObject);
begin
  LogOut('Port geschlossen');
end;

procedure TForm1.ComboStopbitsChange(Sender: TObject);
begin
  case ComboStopbits.ItemIndex of
    0:Com.Stopbits:=sb1;
    1:Com.Stopbits:=sb15;
    2:Com.Stopbits:=sb2;
  end;
  ReOpenCom;
end;

procedure TForm1.ReOpenCom;
//reopens port (if currently active), needed after changes
begin
  if Com.Active then begin
    CmdClose.Enabled:=false;
    Com.Close;
    Com.Open;
    CmdClose.Enabled:=true;
  end;
end;

procedure TForm1.ComboDatabitsChange(Sender: TObject);
begin
  case ComboDatabits.ItemIndex of
    0:Com.Databits:=db4;
    1:Com.Databits:=db5;
    2:Com.Databits:=db6;
    3:Com.Databits:=db7;
    4:Com.Databits:=db8;
  end;
  ReOpenCom;
end;

procedure TForm1.EditSendKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then begin
    CmdSendClick(self);
    key:=#0;
  end;
end;

procedure TForm1.AppException(Sender: TObject; E: Exception);
begin
  with e do
    if pos('Error writing dcb',message)>0 then
      ShowMessage('Die Port-Einstellungen werden nicht untersttzt. (Databits, Stopbits etc.)')
    else
      ShowMessage('Es trat ein Ausnahmefehler auf:'#13#10+message);
end;

procedure TForm1.EditOrdKeyPress(Sender: TObject; var Key: Char);
begin
  if ((key<'0') or (key>'9')) and (key<>#8) then key:=#0;
end;

procedure TForm1.EditOrdChange(Sender: TObject);
begin
  if length(EditOrd.Text)>3 then EditOrd.Text:=copy(EditOrd.Text,length(EditOrd.Text)-3,3);
  if EditOrd.Text<>'' then EditChr.Text:=DecodeText(chr(strtoint(EditOrd.Text)));
end;

procedure TForm1.EditChrKeyPress(Sender: TObject; var Key: Char);
begin
  EditChr.Text:=DecodeText(Key);
  EditOrd.Text:=inttostr(ord(Key));
  Key:=#0;
end;

procedure TForm1.LogOut(text:string);
//adds a line to MemoOut
var
  i : integer;
  b : string;
begin
  if CheckDecode.Checked then
    MemoOut.Lines.Add(DecodeText(text))
  else begin
    //replace #0 by '<0>'
    for i:=1 to length(text) do
      if text[i]=#0 then
        b:=b+'<0>'
      else
        b:=b+text[i];
    MemoOut.Lines.Add(b);
  end;
end;

procedure TForm1.TimerUpdateMemoInTimer(Sender: TObject);
//writes content of global var ReadBuffer to MemoIn
var
  i : integer;
  b : string;
begin
  TimerUpdateMemoIn.Enabled:=false;
  TimerUpdateFinally.Enabled:=false;
  if CheckDecode.Checked then
    b:=DeCodeText(ReadBuffer)
  else begin
    //replace #0 by '<0>'
    for i:=1 to length(ReadBuffer) do
      if ReadBuffer[i]=#0 then
        b:=b+'<0>'
      else
        b:=b+ReadBuffer[i];
  end;
  MemoIn.Lines.Add(inttostr(length(ReadBuffer))+' Byte empfangen:'+b);
  ILSend('RCVD'+myStr(GetTickCount,10)+ReadBuffer);
  ReadBuffer:='';
end;

procedure TForm1.TimerUpdateFinallyTimer(Sender: TObject);
begin
  TimerUpdateMemoInTimer(self);
end;

procedure TForm1.ComBreak(Sender: TObject);
begin
  MemoIn.Lines.Add('Break-Event');
end;

procedure TForm1.ILGet(text:string);
//process remote command
begin
  if copy(text,1,4)<>'SEND' then exit;
  //send
  SendText(copy(text,5,length(text)-4));
end;

procedure TForm1.ServerClientDisconnect(Sender: TObject; Client: TWSocketClient; Error: Word);
//show connect status
var
  i,j:Integer;
begin
  for i:=0 to high(use) do
    if use[i]=(Client as TWSocket) then break;
  for j:=i to high(use)-1 do
    use[j]:=use[j+1];
  SetLength(use,length(use)-1);
  if length(use)=0 then ImageConnect.Visible:=false;
end;

procedure TForm1.CheckInvTXENClick(Sender: TObject);
begin
  Com.SetDTRState(CheckTXEN.Checked xor CheckInvTXEN.Checked);
end;

//////////////////////////// \/ MULTI SERVER \/ ////////////////////////////////
//global vars:
//ilbuffer:string;use:array of TWSocket;started:boolean;//in FormShow
procedure TForm1.ServerDataAvailable(Sender: TObject; Error: Word);
//repeat to all
var
  i,len:integer;
begin
  ilbuffer:=ilbuffer+(Sender as TWSocket).Text;
  if length(ilbuffer)<3 then exit;
  if ilbuffer[1]<>'L' then begin
    ilbuffer:='';
    exit;
  end;
  len:=ord(ilbuffer[2])+256*ord(ilbuffer[3]);
  if length(ilbuffer)<len then exit;
  for i:=0 to high(use) do
    if use[i].state<>wsConnected then begin
      use[i]:=use[high(use)];
      SetLength(use,length(use)-1);
    end else(use[i] as TWSocket).Text:=ilbuffer;
  ILGet(copy(ilbuffer,4,len-3));//pass content
  Delete(ilbuffer,1,len);//delete from buffer
end;

procedure TForm1.ILSend(data:string);
var
  i,len:integer;
  text2send:string;
begin
  len:=length(data)+3;//3 for 'L' + 2 bytes at the beginning which contain length info
  text2send:='L'+chr(len mod 256)+chr(len div 256)+data;
  for i:=0 to high(use) do
    if use[i].state<>wsConnected then begin
      use[i]:=use[high(use)];
      SetLength(use,length(use)-1);
    end else(use[i] as TWSocket).Text:=text2send;
end;

procedure TForm1.ServerClientConnect(Sender: TObject;  Client: TWSocketClient; Error: Word);
begin
  Client.OnDataAvailable:=Server.OnDataAvailable;
  ImageConnect.Visible:=true;
  SetLength(use,length(use)+1);
  use[high(use)]:=(Client as TWSocket);
end;

procedure TForm1.ClientSessionConnected(Sender: TObject; Error: Word);
begin
  SetLength(use,length(use)+1);
  ImageConnect.Visible:=true;
  use[high(use)]:=(Client as TWSocket);
end;

procedure TForm1.ClientDataAvailable(Sender: TObject; Error: Word);
var
  len:integer;
begin
  ilbuffer:=ilbuffer+(Sender as TWSocket).Text;
  if length(ilbuffer)<3 then exit;
  if ilbuffer[1]<>'L' then begin
    ilbuffer:='';
    exit;
  end;
  len:=ord(ilbuffer[2])+256*ord(ilbuffer[3]);
  if length(ilbuffer)<len then exit;
  ILGet(copy(ilbuffer,4,len-3));//pass content
  Delete(ilbuffer,1,len);//delete from buffer
end;

procedure TForm1.ServerSessionConnected(Sender: TObject; Error: Word);
begin
  LogOut('SESSION Started');
end;

procedure TForm1.ClientSessionClosed(Sender: TObject; Error: Word);
begin
  if not started then exit;
  ShowMessage('Server close');
  Application.Terminate;
end;
//////////////////////////// /\ MULTI SERVER /\ ////////////////////////////////

procedure TForm1.FormShow(Sender: TObject);
begin
  if started then exit;
  //auto connect
  Client.Connect;
  while Client.state=wsConnecting do begin
    Application.ProcessMessages;
    if Application.Terminated then exit;
  end;
  if Client.State=wsConnected then begin
    Form1.Caption:=Form1.Caption+' (Interlink Client)';
  end else begin
    Server.Listen;
    Form1.Caption:=Form1.Caption+' (Interlink Server)';
  end;
  started:=true;
end;

function TForm1.MyStr(x,w:integer):string;
begin
  str(x:w,result);
end;

procedure TForm1.SwitchTXENExecute(Sender: TObject);
//STRG+T --> switch TXEN
begin
  CheckTXEN.Checked:=not CheckTXEN.Checked;
end;

procedure TForm1.PopClearMemoClick(Sender: TObject);
//clear memo
begin
  with PopupMenu1.PopupComponent as TMemo do
    Clear;
end;

procedure TForm1.PopClearMemosClick(Sender: TObject);
begin
  MemoIn.Clear;
  MemoOut.Clear;
end;

procedure TForm1.PopCutClick(Sender: TObject);
//cut selected text
begin
  Clipboard.AsText:=(PopupMenu1.PopupComponent as TMemo).SelText;
  (PopupMenu1.PopupComponent as TMemo).SelText:='';
end;

procedure TForm1.PopCopyClick(Sender: TObject);
//copy selected text
begin
  Clipboard.AsText:=(PopupMenu1.PopupComponent as TMemo).SelText;
end;

procedure TForm1.PopMarkAllClick(Sender: TObject);
//select all in memo
begin
  (PopupMenu1.PopupComponent as TMemo).SelectAll;
end;

procedure TForm1.EditChrChange(Sender: TObject);
//do the same as on KeyPress
begin
  if EditChr.Text>'' then
    EditOrd.Text:=inttostr(ord(EditChr.Text[1]));
end;

end.
